/* aps 25apr03  */
#include <stdlib.h>
#include <stdio.h>
#include <glut.h>  /* #include <gl\glut.h>  */
#include <sys/time.h> /* #include <sys/timeb.h>  */
#include <math.h>
#define  MAX(x,y)         (((x)<(y))?(y):(x))
#define  MIN(x,y)         (((x)<(y))?(x):(y))
#define  CLAMP(x,u,v)     (x<u? u : (x>v ? v: x))
#define  ABS(u)           ((u)<0 ? -(u): (u))
#define  FOR(a,b,c)       for((a)=(b);(a)<(c);(a)++)
#define  DOT(p,q)         ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  NRM(p)           sqrt(DOT((p),(p)))
#define  DG            M_PI/180
#define  S(u)          sin(u*DG)
#define  C(u)          cos(u*DG)
#define  CLAMP(x,u,v) (x<u? u : (x>v ? v: x))
#define RND ((float)rand()/RAND_MAX)         /* random fraction */
#define IFCLICK(K,a){static ff=1; if(getbutton(K))ff=1-ff; if(ff){a} }

#define MANY 1048576 
#define NN   10     /* 4^10 = 1048576  */
float AA[MANY][2];  /* buffer for 4^10 points */ 
float aa[4]={.5, .5, .5, 0.};
float bb[4]={0., 0., 0., 0.};
float cc[4]={0., 0., 0., 0.};
float dd[4]={.5, .5, .5, 0.};
float ee[4]={0., 0., .5, 0.};
float ff[4]={0., .5, .5, 0.};
float aaChange[4]={-.05, .035, -.03, -.015};
float bbChange[4]={0, .004, -.026, .028};
float ccChange[4]={0, -.004, .023, .026};
float ddChange[4]={-.034, .035, -.028, .024};
float eeChange[4]={0, 0, -.05, 0};
float ffChange[4]={0, -.034, -.034, .0044};
int mm=0;
/***********************************************************/
void loadA(void){ int kk;   /* with random fractional coords*/
FOR(kk,0,MANY){AA[kk][0]=RND; AA[kk][1]=RND;} 
}
/***********************************************************/
void zeroA(void){ int kk;   /* with random fractional coords*/
FOR(kk,0,MANY){AA[kk][0]=AA[kk][1]=0;} 
}
/***********************************************************/
void testdisplay(){ int kk;
  FOR(kk,0,MANY){  
      glBegin(GL_POINTS);                 /* draw a */
        glColor3f(1.0,1.0,1.0);
        glVertex2fv(AA[kk]);                  /* point  */
      glEnd();
  }
}
/***********************************************************/
void display(){  int uu,kk,top,xx;

  FOR(uu,0,NN){ top = (int)pow(4,uu);   /* top of stack */
  FOR(kk,0,top){
  AA[top + 3*kk][0]  = aa[1]*AA[kk][0]+bb[1]*AA[kk][1]+ee[1];
  AA[top + 3*kk][1]  = cc[1]*AA[kk][0]+dd[1]*AA[kk][1]+ff[1];
  AA[top + 3*kk+1][0]= aa[2]*AA[kk][0]+bb[2]*AA[kk][1]+ee[2];
  AA[top + 3*kk+1][1]= cc[2]*AA[kk][0]+dd[2]*AA[kk][1]+ff[2];
  AA[top + 3*kk+2][0]= aa[3]*AA[kk][0]+bb[3]*AA[kk][1]+ee[3];
  AA[top + 3*kk+2][1]= cc[3]*AA[kk][0]+dd[3]*AA[kk][1]+ff[3];
  AA[kk][0]          = aa[0]*AA[kk][0]+bb[0]*AA[kk][1]+ee[0];
  AA[kk][1]          = cc[0]*AA[kk][0]+dd[0]*AA[kk][1]+ff[0];
      glBegin(GL_POINTS);
        glColor3f(1.0,1.0,1.0);
        glVertex2fv(AA[kk]);
        glVertex2fv(AA[top+3*kk]);
        glVertex2fv(AA[top+3*kk+1]);
        glVertex2fv(AA[top+3*kk+2]);
      glEnd();
  }}
 
  if (mm<11) {
  FOR(xx,0,3){
    aa[xx]=aa[xx]+aaChange[xx];
    bb[xx]=bb[xx]+bbChange[xx];
    cc[xx]=cc[xx]+ccChange[xx];
    dd[xx]=dd[xx]+ddChange[xx];
    ee[xx]=ee[xx]+eeChange[xx];
    ff[xx]=ff[xx]+ffChange[xx];
    glClear(GL_COLOR_BUFFER_BIT);
  }}
  mm++;

}
/***********************************************************/
void keyboard(unsigned char key, int x, int y){
  switch(key){ 
     case  27: exit(0); break;        /* escape with the  (ESC) key  */ 
     case 'w': glClear(GL_COLOR_BUFFER_BIT); break; /* (W)ipe screen */
   }
}
/***********************************************************/
void idle(void){ glutPostRedisplay(); } 
/***********************************************************/
int main(int argc, char **argv){  /* pure GLUTtery here */ 
  /* loadA(); */
  zeroA();
  glutInitWindowSize(400, 400);        
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB); 
  glutCreateWindow("<< Barnsley's Fern in GLUT >>");
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-1,1,0,1.,1.,-1.);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
